'use strict';

// NOTE: Remember Relationship.createThroughModelFactory needs
// to be updated when the design of the model declaration is finished.

var Post = {
  attributes: {
    id: {

    },
    title: {

    },
    type: {

    },
    user_id: {

    },
    created_at: {

    },
    updated_at: {

    },
    user: function(context) {
      return context.belongsToOne('user', 'id', 'user_id');
    },
    items: function(context) {
      return context.hasMany('post_item', 'id', 'post_id');
    },
    media: function(context) {
      return context.hasOne('media', 'id', 'post_id');
    },
    tags: function(context) {
      // target, throughTable, selfThroughIdentifer, selfIdentifer, targetThroughIdentifer, targetIdentifer
      return context.belongsToMany('tag', 'post_tag', 'post_id', 'id', 'tag_id', 'id');
    }
  },
  pre: {},
  post: {},
  method: {},
  static: {}
};

Post.pre.create = function(model, resolve) {
  console.log('PRE CREATE');
  resolve(model);
};

Post.pre.save = function(model, resolve) {
  console.log('PRE SAVE');
  resolve(model);
};

Post.post.create = function(model, resolve) {
  console.log('POST CREATE');
  resolve(model);
};

Post.post.save = function(model, resolve) {
  console.log('POST SAVE');
  resolve(model);
};

Post.method.combineTitle = function() {
  console.log('METHOD');
};

Post.static.findOrCreateByTitle = function() {
  console.log('STATIC');
};

module.exports = Post;