'use strict';
require('./bootstrap');

describe('ORM', function() {

  let Post = ORM.models.post;
  let User = ORM.models.user;
  let Tag = ORM.models.tag;

  it('should', function(done) {

    let post;

    // Create
    Promise.resolve()

    .then(() => {
      return Post.create({
        title: 'Hel rld',
        type: 'ordered',
        tags: [
          { name: 'red' },
        ],
        user: {
          fullname: 'red person',
          email: 'red@asgmail.com',
          username: 'red',
          password: 'password'
        }
      });
    })

    // Update
    .then((model) => {
      console.log('CREATE', model);
      post = model;
      return Post.update({ id: post.id }, {
        title: 'Updated Title!'
      });
    })

    // Find
    .then((model) => {
      console.log('UPDATE', model);
      return Post.find({
        title: 'Updated Title!',
        tags: [
          { name: 'red' },
        ]
      });
    })

    // Delete
    .then((model) => {
      console.log('FIND', model);
      return Post.delete({ id: post.id });
    })
    .then((model) => {
      console.log('DELETE', model);
      return User.delete({ id: post.user.id });
    })
    .then((model) => {
      console.log('DELETE', model);
      return Tag.delete({ id: post.tags[0].id });
    })
    .then((model) => {
      console.log('DELETE', model);
      done();
    })

    // Error
    .catch((error) => {
      console.error(error);
      done();
    });

  });

});